<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Nuclear Power</title>
</head>
<body>
  <style>
    * {
      box-sizing: border-box;
      margin: 0;
    }

    body {
      font-size: 12px;
    }

    .app {
      display: flex;
      justify-content: space-around;
      align-items: center;
      background-image: url('./img/bg.jpg');
      background-repeat: no-repeat;
      background-size: cover;
      width: 100vw;
      height: 100vh;
    }

    .header {
      font-size: 1.8rem;
      text-transform: uppercase;
      color: #fff;
      text-align: center;
      margin-bottom: 30px;
      -webkit-text-stroke-width: 1.5px;
    }

    .lever-container {
      display: flex;
      position: relative;
      background: rgba(240, 233, 233, 0.5);
      box-shadow: 0 0 100px 100px #5e6b64 inset;
      border-radius: 20px;
      border: 3px solid #292c2a;
      height: 40vh;
      padding: 40px 20px 50px;
      min-height: 350px;
      min-width: 700px;
    }

    .lever-container::before {
      content: '';
      background: url('./img/circle.png');
      background-size: contain;
      position: absolute;
      left: -80px;
      top: -80px;
      width: 160px;
      height: 160px;
    }

    .lever {
      width: 25%;
      display: flex;
      align-items:  center;
      flex-flow: column;
    }

    .lever__header {
      font-size: 1.3rem;
      color:#2b160c;
      font-weight: bold;
      margin-bottom: 10px;
    }

    .lever__control {
      width: 30px; 
      background-color: #5cbf2a;
      flex: 1 1 auto;
      position: relative;
      z-index: 1;
      --sq-height: 0px;
    }

    .lever__control::after{
      content: '';
      display: block;
      width: 30px;
      top: 0;
      left: 0;
      position: absolute;
      background-color: #ed2913;
      height: var(--sq-height);
      transition: 1s;
      z-index: 1000;
    }

    .control__runner {
      position: absolute;
      top: 0;
      left: -15px;
      width: 60px;
      height: 40px;
      background-color: #f5ba18;
      box-shadow: 0 0 10px 7px rgba(0,0,0,0.7) inset;
      border-radius: 5px;
      transition: 1s;
      z-index: 100;
      padding: 10px;
    }

    .line {
      height: 1px;
      width: 100%;
      background-color: #000;
      margin-bottom: 7px;
    }

    .line:last-child {
      margin-bottom: 0;
    }

    .notify-container {
      width: 250px;
	    min-height: 100px;
      padding: 20px 10px;
      border-radius: 30px;
	    box-shadow: 2px 2px 4px #888;
      opacity: 0;
      transition: 0.5s;
    }

    .speech {
	    text-align: center;
      font-size: 1.3rem;
      word-wrap: break-word;
    }
  </style>

  <div class="app">
    <section class="section-lever">
      <header class="header">nuclear power control panel</header>
      <div class="lever-container">
        <div class="lever-container__lever lever">
          <p class="lever__header">district 1</p>
          <div class="lever__control control">
            <div class="control__runner control__runner--1">
              <div class="line"></div>
              <div class="line"></div>
              <div class="line"></div>
            </div>
          </div>
        </div>
        <div class="lever-container__lever lever">
          <p class="lever__header">district 2</p>
          <div class="lever__control control">
            <div class="control__runner">
              <div class="line"></div>
              <div class="line"></div>
              <div class="line"></div>
            </div>
          </div>
        </div>
        <div class="lever-container__lever lever">
          <p class="lever__header">district 3</p>
          <div class="lever__control control">
            <div class="control__runner">
              <div class="line"></div>
              <div class="line"></div>
              <div class="line"></div>
            </div>
          </div>
        </div>
        <div class="lever-container__lever lever">
          <p class="lever__header">district 4</p>
          <div class="lever__control control">
            <div class="control__runner">
              <div class="line"></div>
              <div class="line"></div>
              <div class="line"></div>
            </div>
          </div>
        </div>
      </div>
    </section>
    <div class="notify-container">
      <p class="speech"></p>
    </div>
  </div>

  <script>
    const runners = document.querySelectorAll('.control__runner');
    const levers= document.querySelectorAll('.lever__control');
    const initialPos = '0';
    const activePos = `${levers[0].offsetHeight - 40}px`;

    function moveLevers(states) {
      Object.values(states).forEach((el, index ) => {
        const pos = (el === true) ? activePos : initialPos;
        runners[index].style.top = pos;
        levers[index].style.setProperty('--sq-height', `${pos}`);
      });
    }

    const greetNotifierStyle = {
      backgroundColor: 'rgba(247, 214, 124, 0.9)',
      border: '1px solid #e8ad0c',
    };

    const failNotifierStyle = {
      backgroundColor: 'rgba(250, 177, 155, 0.9)',
      border: '1px solid #fc693d',
    };

    const successNotifierStyle = {
      backgroundColor: 'rgba(206, 250, 165, 0.9)',
      border: '1px solid #374f35',
    };

    const notifier = document.querySelector('.notify-container');

    function createMessage(styleConfig, message) {
      notifier.querySelector('.speech').innerText = message;
      Object.assign(notifier.style, styleConfig);
    }

    function showMessage(timetoDisappear) {
      notifier.style.opacity = '1';

      setTimeout(() => {
        notifier.style.opacity = '0';
      }, timetoDisappear);
    }

    let socket = new WebSocket('ws://vps.yojji.io', 'vlada_yurchenko');

    const requestForCheck = {
      action: 'check', 
      'lever1': 0, 
      'lever2': 1, 
      stateId: 'some-state-id' 
    }

    const powerOff = {
      action: 'powerOff', 
      stateId: 'some-state-id'
    }

    let states = {
      0: false,
      1: false,
      2: false,
      3: false
    }

    let stateToTurnOff = true;

    socket.onopen = function() {
      createMessage(greetNotifierStyle, 'Hello, let\'s try to turn this machine OFF');
      showMessage(4000);
    };

    socket.onmessage = function(event) {  
      const message = JSON.parse(event.data);

      if (message.newState === 'poweredOff') {
        socket.close();

        createMessage(successNotifierStyle, `Great! Here is your TOKEN: ${message.token}`);
        showMessage(4000);

        return;
      }

      if (message.newState === 'poweredOn') {
        createMessage(failNotifierStyle, 'Still ON. Do not give up! You have one more chance!');
        showMessage(3000);

        stateToTurnOff = false;
      }

      if (message.pulled >= 0) {
        const lever = message.pulled;
        states[lever] = !states[lever];
        requestForCheck.stateId = message.stateId;

        moveLevers(states);

        socket.send(JSON.stringify(requestForCheck));
      }

      if (message.same) {
        states[requestForCheck['lever2']] = states[requestForCheck['lever1']];

        if(requestForCheck['lever2'] < 3) {
          requestForCheck['lever2'] += 1;
        }

        const leversSameFlag = Object.values(states).every(el => el === stateToTurnOff);

        if (leversSameFlag) {
          powerOff.stateId = message.stateId;

          socket.send(JSON.stringify(powerOff));
        }
      }
    };
  </script>
</body>
</html>
